# Couenne::exprMin Class Reference

class for minima More...

`#include <CouenneExprMin.hpp>`

Inheritance diagram for Couenne::exprMin:

List of all members.

## Public Member Functions
| exprMin (expression **al, int n)
| Constructor.
| exprMin (expression *el0, expression *el1)
| Constructor with only two arguments.
exprMin * | clone (Domain *d=NULL) const
| Cloning method.
std::string | printOp () const
| Print operator.
enum pos | printPos () const
| Print operator.
CouNumber | operator() ()
| Function for the evaluation of the expression.
expression * | differentiate (int)
| Differentiation.
expression * | simplify ()
| Simplification.
virtual int | Linearity ()
| get a measure of "how linear" the expression is (see CouenneTypes.h)
void | getBounds (expression *&, expression *&)
virtual exprAux * | standardize (CouenneProblem *, bool addAux=true)
| Reduce expression in standard form, creating additional aux variables (and constraints).
void | generateCuts (expression *w, OsiCuts &cs, const CouenneCutGenerator *cg, t_chg_bounds *=NULL, int=-1, CouNumber=-COUENNE_INFINITY, CouNumber=COUENNE_INFINITY)
| Generate equality between *this and *w.
virtual enum expr_type | code ()
| Code for comparisons.

## Detailed Description

class for minima

Definition at line 29 of file CouenneExprMin.hpp.

## Constructor & Destructor Documentation

Couenne::exprMin::exprMin | ( | expression ** | al,
|  | int | n |
| ) |  |  | `[inline]`

Constructor.

Definition at line 34 of file CouenneExprMin.hpp.

Referenced by clone().

Couenne::exprMin::exprMin | ( | expression * | el0,
|  | expression * | el1 |
| ) |  |  | `[inline]`

Constructor with only two arguments.

Definition at line 38 of file CouenneExprMin.hpp.

References Couenne::exprOp::arglist_.

## Member Function Documentation

exprMin* Couenne::exprMin::clone | ( | Domain * | d = `NULL` | ) | const`[inline, virtual]`

Cloning method.

Reimplemented from Couenne::expression.

Definition at line 45 of file CouenneExprMin.hpp.

References Couenne::exprOp::clonearglist(), exprMin(), and Couenne::exprOp::nargs_.

std::string Couenne::exprMin::printOp | ( |  | ) | const`[inline, virtual]`

Print operator.

Reimplemented from Couenne::exprOp.

Definition at line 49 of file CouenneExprMin.hpp.

enum pos Couenne::exprMin::printPos | ( |  | ) | const`[inline, virtual]`

Print operator.

Reimplemented from Couenne::exprOp.

Definition at line 53 of file CouenneExprMin.hpp.

References Couenne::PRE.

CouNumber Couenne::exprMin::operator() | ( |  | ) | `[inline, virtual]`

Function for the evaluation of the expression.

Compute minimum.

Implements Couenne::expression.

Definition at line 94 of file CouenneExprMin.hpp.

References Couenne::exprOp::arglist_, and Couenne::exprOp::nargs_.

expression* Couenne::exprMin::differentiate | ( | int |  | ) | `[inline, virtual]`

Differentiation.

Reimplemented from Couenne::expression.

Definition at line 60 of file CouenneExprMin.hpp.

expression* Couenne::exprMin::simplify | ( |  | ) | `[inline, virtual]`

Simplification.

Reimplemented from Couenne::exprOp.

Definition at line 64 of file CouenneExprMin.hpp.

virtual int Couenne::exprMin::Linearity | ( |  | ) | `[inline, virtual]`

get a measure of "how linear" the expression is (see CouenneTypes.h)

Reimplemented from Couenne::exprOp.

Definition at line 68 of file CouenneExprMin.hpp.

References Couenne::NONLINEAR.

void Couenne::exprMin::getBounds | ( | expression *& | ,
|  | expression *& |  |
| ) |  |  |

virtual exprAux* Couenne::exprMin::standardize | ( | CouenneProblem * | ,
|  | bool | addAux = `true` |
| ) |  |  | `[inline, virtual]`

Reduce expression in standard form, creating additional aux variables (and constraints).

Reimplemented from Couenne::exprOp.

Definition at line 76 of file CouenneExprMin.hpp.

void Couenne::exprMin::generateCuts | ( | expression * | w,
|  | OsiCuts & | cs,
|  | const CouenneCutGenerator * | cg,
|  | t_chg_bounds * | = `NULL`,
|  | int | = `-1`,
|  | CouNumber | = `-COUENNE_INFINITY`,
|  | CouNumber | = `COUENNE_INFINITY` |
| ) |  |  |

Generate equality between *this and *w.

virtual enum expr_type Couenne::exprMin::code | ( |  | ) | `[inline, virtual]`

Code for comparisons.

Reimplemented from Couenne::exprOp.

Definition at line 87 of file CouenneExprMin.hpp.

References Couenne::COU_EXPRMIN.

The documentation for this class was generated from the following file:

- CouenneExprMin.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines